cern.colt.list

## Class CharArrayList

- java.lang.Object
- - cern.colt.PersistentObject
  - - cern.colt.list.AbstractCollection
    - - cern.colt.list.AbstractList
      - - cern.colt.list.AbstractCharList
        - - cern.colt.list.CharArrayList

- All Implemented Interfaces:
    java.io.Serializable, java.lang.Cloneable

      public class CharArrayList
      extends AbstractCharList

  Resizable list holding `char` elements; implemented with arrays. First see the package summary and javadoc tree view to get the broad picture.
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class cern.colt.PersistentObject

      `serialVersionUID`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CharArrayList()` Constructs an empty list.
    `CharArrayList(char[] elements)` Constructs a list containing the specified elements.
    `CharArrayList(int initialCapacity)` Constructs an empty list with the specified initial capacity.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `add(char element)` Appends the specified element to the end of this list.
    `void` | `beforeInsert(int index, char element)` Inserts the specified element before the specified position into the receiver.
    `int` | `binarySearchFromTo(char key, int from, int to)` Searches the receiver for the specified value using the binary search algorithm.
    `java.lang.Object` | `clone()` Returns a deep copy of the receiver.
    `CharArrayList` | `copy()` Returns a deep copy of the receiver; uses `clone()` and casts the result.
    `char[]` | `elements()` Returns the elements currently stored, including invalid elements between size and capacity, if any.
    `AbstractCharList` | `elements(char[] elements)` Sets the receiver's elements to be the specified array (not a copy of it).
    `void` | `ensureCapacity(int minCapacity)` Ensures that the receiver can hold at least the specified number of elements without needing to allocate new internal memory.
    `boolean` | `equals(java.lang.Object otherObj)` Compares the specified Object with the receiver.
    `boolean` | `forEach(CharProcedure procedure)` Applies a procedure to each element of the receiver, if any.
    `char` | `get(int index)` Returns the element at the specified position in the receiver.
    `char` | `getQuick(int index)` Returns the element at the specified position in the receiver; WARNING: Does not check preconditions.
    `int` | `indexOfFromTo(char element, int from, int to)` Returns the index of the first occurrence of the specified element.
    `int` | `lastIndexOfFromTo(char element, int from, int to)` Returns the index of the last occurrence of the specified element.
    `AbstractCharList` | `partFromTo(int from, int to)` Returns a new list of the part of the receiver between `from`, inclusive, and `to`, inclusive.
    `boolean` | `removeAll(AbstractCharList other)` Removes from the receiver all elements that are contained in the specified list.
    `void` | `replaceFromToWithFrom(int from, int to, AbstractCharList other, int otherFrom)` Replaces a number of elements in the receiver with the same number of elements of another list.
    `boolean` | `retainAll(AbstractCharList other)` Retains (keeps) only the elements in the receiver that are contained in the specified other list.
    `void` | `reverse()` Reverses the elements of the receiver.
    `void` | `set(int index, char element)` Replaces the element at the specified position in the receiver with the specified element.
    `void` | `setQuick(int index, char element)` Replaces the element at the specified position in the receiver with the specified element; WARNING: Does not check preconditions.
    `void` | `shuffleFromTo(int from, int to)` Randomly permutes the part of the receiver between `from` (inclusive) and `to` (inclusive).
    `void` | `sortFromTo(int from, int to)` Sorts the specified range of the receiver into ascending order.
    `void` | `trimToSize()` Trims the capacity of the receiver to be the receiver's current size.

    - ### Methods inherited from class cern.colt.list.AbstractCharList

      `addAllOfFromTo, beforeInsertAllOfFromTo, binarySearch, contains, delete, fillFromToWith, indexOf, lastIndexOf, mergeSortFromTo, mergeSortFromTo, quickSortFromTo, quickSortFromTo, removeFromTo, replaceFromToWithFromTo, replaceFromWith, size, times, toList, toString`

    - ### Methods inherited from class cern.colt.list.AbstractList

      `addAllOf, beforeInsertAllOf, clear, mergeSort, quickSort, remove, setSize, shuffle, sort`

    - ### Methods inherited from class cern.colt.list.AbstractCollection

      `isEmpty`

    - ### Methods inherited from class java.lang.Object

      `getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### CharArrayList

          public CharArrayList()

      Constructs an empty list.

    - #### CharArrayList

          public CharArrayList(char[] elements)

      Constructs a list containing the specified elements. The initial size and capacity of the list is the length of the array. WARNING: For efficiency reasons and to keep memory usage low, the array is not copied. So if subsequently you modify the specified array directly via the [] operator, be sure you know what you're doing.
      Parameters:
        `elements` - the array to be backed by the the constructed list

    - #### CharArrayList

          public CharArrayList(int initialCapacity)

      Constructs an empty list with the specified initial capacity.
      Parameters:
        `initialCapacity` - the number of elements the receiver can hold without auto-expanding itself by allocating new internal memory.

  - ### Method Detail

    - #### add

          public void add(char element)

      Appends the specified element to the end of this list.
      Overrides:
        `add` in class `AbstractCharList`
      Parameters:
        `element` - element to be appended to this list.

    - #### beforeInsert

          public void beforeInsert(int index,
                          char element)

      Inserts the specified element before the specified position into the receiver. Shifts the element currently at that position (if any) and any subsequent elements to the right.
      Overrides:
        `beforeInsert` in class `AbstractCharList`
      Parameters:
        `index` - index before which the specified element is to be inserted (must be in [0,size]).
        `element` - element to be inserted.
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (`index < 0 || index > size()`).

    - #### binarySearchFromTo

          public int binarySearchFromTo(char key,
                               int from,
                               int to)

      Searches the receiver for the specified value using the binary search algorithm. The receiver must must be sorted (as by the sort method) prior to making this call. If it is not sorted, the results are undefined: in particular, the call may enter an infinite loop. If the receiver contains multiple elements equal to the specified object, there is no guarantee which instance will be found.
      Overrides:
        `binarySearchFromTo` in class `AbstractCharList`
      Parameters:
        `key` - the value to be searched for.
        `from` - the leftmost search position, inclusive.
        `to` - the rightmost search position, inclusive.
      Returns:
        index of the search key, if it is contained in the receiver; otherwise, `(-(insertion point) - 1)`. The insertion point is defined as the the point at which the value would be inserted into the receiver: the index of the first element greater than the key, or `receiver.size()`, if all elements in the receiver are less than the specified key. Note that this guarantees that the return value will be >= 0 if and only if the key is found.
      See Also:
        `Sorting`, `Arrays`

    - #### clone

          public java.lang.Object clone()

      Returns a deep copy of the receiver.
      Overrides:
        `clone` in class `AbstractCharList`
      Returns:
        a deep copy of the receiver.

    - #### copy

          public CharArrayList copy()

      Returns a deep copy of the receiver; uses `clone()` and casts the result.
      Returns:
        a deep copy of the receiver.

    - #### elements

          public char[] elements()

      Returns the elements currently stored, including invalid elements between size and capacity, if any. WARNING: For efficiency reasons and to keep memory usage low, the array is not copied. So if subsequently you modify the returned array directly via the [] operator, be sure you know what you're doing.
      Overrides:
        `elements` in class `AbstractCharList`
      Returns:
        the elements currently stored.

    - #### elements

          public AbstractCharList elements(char[] elements)

      Sets the receiver's elements to be the specified array (not a copy of it). The size and capacity of the list is the length of the array. WARNING: For efficiency reasons and to keep memory usage low, the array is not copied. So if subsequently you modify the specified array directly via the [] operator, be sure you know what you're doing.
      Overrides:
        `elements` in class `AbstractCharList`
      Parameters:
        `elements` - the new elements to be stored.
      Returns:
        the receiver itself.

    - #### ensureCapacity

          public void ensureCapacity(int minCapacity)

      Ensures that the receiver can hold at least the specified number of elements without needing to allocate new internal memory. If necessary, allocates new internal memory and increases the capacity of the receiver.
      Specified by:
        `ensureCapacity` in class `AbstractCharList`
      Parameters:
        `minCapacity` - the desired minimum capacity.

    - #### equals

          public boolean equals(java.lang.Object otherObj)

      Compares the specified Object with the receiver. Returns true if and only if the specified Object is also an ArrayList of the same type, both Lists have the same size, and all corresponding pairs of elements in the two Lists are identical. In other words, two Lists are defined to be equal if they contain the same elements in the same order.
      Overrides:
        `equals` in class `AbstractCharList`
      Parameters:
        `otherObj` - the Object to be compared for equality with the receiver.
      Returns:
        true if the specified Object is equal to the receiver.

    - #### forEach

          public boolean forEach(CharProcedure procedure)

      Applies a procedure to each element of the receiver, if any. Starts at index 0, moving rightwards.
      Overrides:
        `forEach` in class `AbstractCharList`
      Parameters:
        `procedure` - the procedure to be applied. Stops iteration if the procedure returns `false`, otherwise continues.
      Returns:
        `false` if the procedure stopped before all elements where iterated over, `true` otherwise.

    - #### get

          public char get(int index)

      Returns the element at the specified position in the receiver.
      Overrides:
        `get` in class `AbstractCharList`
      Parameters:
        `index` - index of element to return.
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (index < 0 || index >= size()).

    - #### getQuick

          public char getQuick(int index)

      Returns the element at the specified position in the receiver; WARNING: Does not check preconditions. Provided with invalid parameters this method may return invalid elements without throwing any exception! You should only use this method when you are absolutely sure that the index is within bounds. Precondition (unchecked): `index >= 0 && index < size()`.
      Parameters:
        `index` - index of element to return.

    - #### indexOfFromTo

          public int indexOfFromTo(char element,
                          int from,
                          int to)

      Returns the index of the first occurrence of the specified element. Returns `-1` if the receiver does not contain this element. Searches between `from`, inclusive and `to`, inclusive. Tests for identity.
      Overrides:
        `indexOfFromTo` in class `AbstractCharList`
      Parameters:
        `element` - element to search for.
        `from` - the leftmost search position, inclusive.
        `to` - the rightmost search position, inclusive.
      Returns:
        the index of the first occurrence of the element in the receiver; returns `-1` if the element is not found.
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

    - #### lastIndexOfFromTo

          public int lastIndexOfFromTo(char element,
                              int from,
                              int to)

      Returns the index of the last occurrence of the specified element. Returns `-1` if the receiver does not contain this element. Searches beginning at `to`, inclusive until `from`, inclusive. Tests for identity.
      Overrides:
        `lastIndexOfFromTo` in class `AbstractCharList`
      Parameters:
        `element` - element to search for.
        `from` - the leftmost search position, inclusive.
        `to` - the rightmost search position, inclusive.
      Returns:
        the index of the last occurrence of the element in the receiver; returns `-1` if the element is not found.
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

    - #### partFromTo

          public AbstractCharList partFromTo(int from,
                                    int to)

      Returns a new list of the part of the receiver between `from`, inclusive, and `to`, inclusive.
      Overrides:
        `partFromTo` in class `AbstractCharList`
      Parameters:
        `from` - the index of the first element (inclusive).
        `to` - the index of the last element (inclusive).
      Returns:
        a new list
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

    - #### removeAll

          public boolean removeAll(AbstractCharList other)

      Removes from the receiver all elements that are contained in the specified list. Tests for identity.
      Overrides:
        `removeAll` in class `AbstractCharList`
      Parameters:
        `other` - the other list.
      Returns:
        `true` if the receiver changed as a result of the call.

    - #### replaceFromToWithFrom

          public void replaceFromToWithFrom(int from,
                                   int to,
                                   AbstractCharList other,
                                   int otherFrom)

      Replaces a number of elements in the receiver with the same number of elements of another list. Replaces elements in the receiver, between `from` (inclusive) and `to` (inclusive), with elements of `other`, starting from `otherFrom` (inclusive).
      Overrides:
        `replaceFromToWithFrom` in class `AbstractCharList`
      Parameters:
        `from` - the position of the first element to be replaced in the receiver
        `to` - the position of the last element to be replaced in the receiver
        `other` - list holding elements to be copied into the receiver.
        `otherFrom` - position of first element within other list to be copied.

    - #### retainAll

          public boolean retainAll(AbstractCharList other)

      Retains (keeps) only the elements in the receiver that are contained in the specified other list. In other words, removes from the receiver all of its elements that are not contained in the specified other list.
      Overrides:
        `retainAll` in class `AbstractCharList`
      Parameters:
        `other` - the other list to test against.
      Returns:
        `true` if the receiver changed as a result of the call.

    - #### reverse

          public void reverse()

      Reverses the elements of the receiver. Last becomes first, second last becomes second first, and so on.
      Overrides:
        `reverse` in class `AbstractCharList`

    - #### set

          public void set(int index,
                 char element)

      Replaces the element at the specified position in the receiver with the specified element.
      Overrides:
        `set` in class `AbstractCharList`
      Parameters:
        `index` - index of element to replace.
        `element` - element to be stored at the specified position.
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (index < 0 || index >= size()).

    - #### setQuick

          public void setQuick(int index,
                      char element)

      Replaces the element at the specified position in the receiver with the specified element; WARNING: Does not check preconditions. Provided with invalid parameters this method may access invalid indexes without throwing any exception! You should only use this method when you are absolutely sure that the index is within bounds. Precondition (unchecked): `index >= 0 && index < size()`.
      Parameters:
        `index` - index of element to replace.
        `element` - element to be stored at the specified position.

    - #### shuffleFromTo

          public void shuffleFromTo(int from,
                           int to)

      Randomly permutes the part of the receiver between `from` (inclusive) and `to` (inclusive).
      Overrides:
        `shuffleFromTo` in class `AbstractCharList`
      Parameters:
        `from` - the index of the first element (inclusive) to be permuted.
        `to` - the index of the last element (inclusive) to be permuted.
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

    - #### sortFromTo

          public void sortFromTo(int from,
                        int to)

      Sorts the specified range of the receiver into ascending order. The sorting algorithm is dynamically chosen according to the characteristics of the data set. Currently quicksort and countsort are considered. Countsort is not always applicable, but if applicable, it usually outperforms quicksort by a factor of 3-4.

      Best case performance: O(N).

      Worst case performance: O(N^2) (a degenerated quicksort).
      Best case space requirements: 0 KB.
      Worst case space requirements: 40 KB.
      Overrides:
        `sortFromTo` in class `AbstractList`
      Parameters:
        `from` - the index of the first element (inclusive) to be sorted.
        `to` - the index of the last element (inclusive) to be sorted.
      Throws:
        `java.lang.IndexOutOfBoundsException` - index is out of range (`size()>0 && (from<0 || from>to || to>=size())`).

    - #### trimToSize

          public void trimToSize()

      Trims the capacity of the receiver to be the receiver's current size. Releases any superfluos internal memory. An application can use this operation to minimize the storage of the receiver.
      Overrides:
        `trimToSize` in class `AbstractList`

Jump to the Colt Homepage